function love.load ()
	--------------------------------------------
	images = { } --All images!
	--Load basic drawable variables such as background and UI
	loadBasicImages ()
	images.black_tile = love.graphics.newImage("black_tile" .. ".png")
	images.white_tile = love.graphics.newImage("white_tile" .. ".png")
	background_img = love.graphics.newImage("back.png")
	numbers_img = love.graphics.newImage("numbers.png")
	pixelfont_font = love.graphics.newFont("pixelfont.ttf",27)
	player_text = love.graphics.newText( pixelfont_font, "Black player's turn")
	piece_text = love.graphics.newText( pixelfont_font, "rook")
----------------------------------------------
	--Initialize variables here



	--Tables
	backTiles_table = { }
	entities_table = { }
	board_table = { }
	movesAble_table = { }
	whiteKills_table = { }
	blackKills_table = { }

	--Number
	rotation = 0
	lastTile = 0
	onMap_x = 0
	onMap_y = 0
	placeholderNumber = 0
	targetTile = 11
	entityNumber = 0
	positionOnBoard = 11
	drawCordinate_x = 0
	drawCordinate_y = 0
	scalingNumber = love.graphics.getWidth() / 1920
	middleOfBoard_x = love.graphics.getWidth() / 2
	middleOfBoard_y = love.graphics.getHeight() / 2

	--Strings
	lastPickedPiece = "bishop"
	currentPlayer = "White"
	backTile = "black"
	color = "black"
	piece = "pawn"
-----------------------------------------------
	--Create onStart things such as tiles onStart
	createBasicTiles ()
	createBasicSet ()


	--Custom set
	entities_table[1].piece = "rook"
	entities_table[2].piece = "knight"
	entities_table[3].piece = "bishop"
	entities_table[4].piece = "king"
	entities_table[5].piece = "queen"
	entities_table[6].piece = "bishop"
	entities_table[7].piece = "knight"
	entities_table[8].piece = "rook"
	--White
	entities_table[25].piece = "rook"
	entities_table[26].piece = "knight"
	entities_table[27].piece = "bishop"
	entities_table[28].piece = "king"
	entities_table[29].piece = "queen"
	entities_table[30].piece = "bishop"
	entities_table[31].piece = "knight"
	entities_table[32].piece = "rook"
end

--------------------------------------------------------------------------------
---- BASIC LOAD FUNCTIONS ------------------------------------------------------
--------------------------------------------------------------------------------

function createBasicTiles ()
	positionOnBoard = 10
	for i=1, 64, 1 do
		positionOnBoard = positionOnBoard + 1
		backTiles_table[positionOnBoard] = backTile
		if backTile == "black" then
			backTile = "white"
		else
			backTile = "black"
		end
		if math.fmod (i, 8) == 0 then
			positionOnBoard = positionOnBoard + 2
			if backTile == "black" then
				backTile = "white"
			else
				backTile = "black"
			end
		end
	end
end

function createBasicSet()
	for i=1,10, 1 do

	end
	positionOnBoard = 10
	for i=1, 32, 1 do
		positionOnBoard = positionOnBoard + 1
		board_table[positionOnBoard] = i
		entities_table[i] = {piece = piece, color = color}
		if math.fmod (i, 8) == 0 then
			positionOnBoard = positionOnBoard + 2
		end
		if i == 16 then
			positionOnBoard = 70
			color = "white"
		end
	end
end

function loadBasicImages()
	images.black_tile = love.graphics.newImage("black_tile" .. ".png")
	images.white_tile = love.graphics.newImage("white_tile" .. ".png")
	images.black_rook = love.graphics.newImage("black_rook" .. ".png")
	images.white_rook = love.graphics.newImage("white_rook" .. ".png")
	images.black_pawn = love.graphics.newImage("black_pawn" .. ".png")
	images.white_pawn = love.graphics.newImage("white_pawn" .. ".png")
	images.black_bishop = love.graphics.newImage("black_bishop" .. ".png")
	images.white_bishop = love.graphics.newImage("white_bishop" .. ".png")
	images.black_queen = love.graphics.newImage("black_queen" .. ".png")
	images.white_queen = love.graphics.newImage("white_queen" .. ".png")
	images.black_king = love.graphics.newImage("black_king" .. ".png")
	images.white_king = love.graphics.newImage("white_king" .. ".png")
	images.black_knight = love.graphics.newImage("black_knight" .. ".png")
	images.white_knight = love.graphics.newImage("white_knight" .. ".png")
	images.black_square = love.graphics.newImage("black_square" .. ".png")
	images.white_square = love.graphics.newImage("white_square" .. ".png")
	images.black_square_attack = love.graphics.newImage("black_square_attack" .. ".png")
	images.white_square_attack = love.graphics.newImage("white_square_attack" .. ".png")
end


function love.draw (dt)
	love.graphics.draw(background_img, middleOfBoard_x - 1536*scalingNumber*0.85/2, middleOfBoard_y - 1536*scalingNumber*0.85/2, 0 , scalingNumber*0.85)
	drawTiles()
	drawBoard ()
	drawAbleSquares ()
	drawDeadPiecesCollection ()
	love.graphics.draw(numbers_img, middleOfBoard_x - 4*108*scalingNumber - 70*scalingNumber, middleOfBoard_y - 4*108*scalingNumber + 20*scalingNumber, 0, 0.835*scalingNumber)
	player_text = love.graphics.newText( pixelfont_font, currentPlayer .." player's turn")
	love.graphics.draw(player_text, 5*scalingNumber, 50, 0, scalingNumber)
	player_text = love.graphics.newText( pixelfont_font, lastPickedPiece)
	love.graphics.draw(player_text, 5*scalingNumber, 125, 0, scalingNumber)
end


--------------------------------------------------------------------------------
---- DRAWING FUNCTIONS ---------------------------------------------------------
--------------------------------------------------------------------------------

function drawTiles ()
	drawCordinate_x = middleOfBoard_x - 4*108*scalingNumber
	drawCordinate_y = middleOfBoard_y - 4*108*scalingNumber
	positionOnBoard = 10
	for i=1, 64, 1 do
		positionOnBoard = positionOnBoard + 1
		love.graphics.draw(images[backTiles_table[positionOnBoard] .. "_tile"], drawCordinate_x, drawCordinate_y, 0, scalingNumber)
		drawCordinate_x = drawCordinate_x + 108*scalingNumber
		if math.fmod(i, 8) == 0 then
			positionOnBoard = positionOnBoard + 2
			drawCordinate_y = drawCordinate_y + 108*scalingNumber
			drawCordinate_x = middleOfBoard_x - 4*108*scalingNumber
		end
	end
end



function drawBoard()
	drawCordinate_x = middleOfBoard_x - 4*108*scalingNumber
	drawCordinate_y = middleOfBoard_y - 4*108*scalingNumber
	positionOnBoard = 10
	for i=1, 64, 1 do
		positionOnBoard = positionOnBoard + 1
		if board_table[positionOnBoard] ~= nil then
			targetTile = board_table[positionOnBoard]
			if currentPlayer == "Black" then
				if lastTile == positionOnBoard then
					love.graphics.draw(images[entities_table[targetTile].color .. "_" .. entities_table[targetTile].piece], drawCordinate_x - 0.1*scalingNumber*108 + 108*scalingNumber , drawCordinate_y - 0.1*scalingNumber*108 - 30*scalingNumber + 108*scalingNumber, math.pi, scalingNumber*0.8)
				else
					love.graphics.draw(images[entities_table[targetTile].color .. "_" .. entities_table[targetTile].piece], drawCordinate_x - 0.1*scalingNumber*108+ 108*scalingNumber, drawCordinate_y - 0.1*scalingNumber*108+ 108*scalingNumber, math.pi, scalingNumber*0.8)
				end
			else
				if lastTile == positionOnBoard then
					love.graphics.draw(images[entities_table[targetTile].color .. "_" .. entities_table[targetTile].piece], drawCordinate_x + 0.1*scalingNumber*108, drawCordinate_y + 0.1*scalingNumber*108 - 30*scalingNumber, 0, scalingNumber*0.8)
				else
					love.graphics.draw(images[entities_table[targetTile].color .. "_" .. entities_table[targetTile].piece], drawCordinate_x + 0.1*scalingNumber*108, drawCordinate_y + 0.1*scalingNumber*108, 0, scalingNumber*0.8)
				end
			end
		end
		drawCordinate_x = drawCordinate_x + 108*scalingNumber
		if math.fmod(i, 8) == 0 then
			positionOnBoard = positionOnBoard + 2
			drawCordinate_y = drawCordinate_y + 108*scalingNumber
			drawCordinate_x = middleOfBoard_x - 4*108*scalingNumber
		end
	end
end


function drawAbleSquares ()
	if movesAble_table ~= nil then
	drawCordinate_x = middleOfBoard_x - 4*108*scalingNumber
	drawCordinate_y = middleOfBoard_y - 4*108*scalingNumber
	positionOnBoard = 10
		for i=1, 64, 1 do
			positionOnBoard = positionOnBoard + 1
			if movesAble_table[positionOnBoard] ~= nil and backTiles_table[positionOnBoard] ~= nil then
				if movesAble_table[positionOnBoard] == "attack" then
					love.graphics.draw(images[backTiles_table[positionOnBoard] .. "_square_attack"], drawCordinate_x, drawCordinate_y, 0, scalingNumber)
				else
					love.graphics.draw(images[backTiles_table[positionOnBoard] .. "_square"], drawCordinate_x, drawCordinate_y, 0, scalingNumber)
				end
			end
			drawCordinate_x = drawCordinate_x + 108*scalingNumber
			if math.fmod(i, 8) == 0 then
				positionOnBoard = positionOnBoard + 2
				drawCordinate_y = drawCordinate_y + 108*scalingNumber
				drawCordinate_x = middleOfBoard_x - 4*108*scalingNumber
			end
		end
	end
end

function drawDeadPiecesCollection ()
	positionOnBoard = 0
	if whiteKills_table[1] ~= nil then
		for i=1, #whiteKills_table do
			love.graphics.draw(images[whiteKills_table[i].color .. "_" .. whiteKills_table[i].piece], middleOfBoard_x + 5*108*scalingNumber + 10*scalingNumber + i*scalingNumber*40, middleOfBoard_y - 4*108*scalingNumber + i*scalingNumber*40, 0, scalingNumber*0.7)
		end
	end
	if blackKills_table[1] ~= nil then
		for i=1, #blackKills_table do
			love.graphics.draw(images[blackKills_table[i].color .. "_" .. blackKills_table[i].piece], middleOfBoard_x + 5*108*scalingNumber + 10*scalingNumber + i*scalingNumber*40, 200*scalingNumber + middleOfBoard_y - 4*108*scalingNumber + i*scalingNumber*40, 0, scalingNumber*0.7)
		end
	end
end
--------------------------------------------------------------------------------
---- IN-GAME FUNCTIONS ---------------------------------------------------------
--------------------------------------------------------------------------------


function switchToPlayer (colorToSwitch)
	if colorToSwitch ~= currentPlayer then
		currentPlayer = colorToSwitch
		--SWITCHEROOOOOO
		positionOnBoard = 10
		--for i=1, 32, 1 do
			--positionOnBoard = positionOnBoard + 1
			--placeholderNumber = board_table[positionOnBoard]
			--board_table[positionOnBoard] = board_table[99 - positionOnBoard]
			--board_table[99 - positionOnBoard] = placeholderNumber
			--if math.fmod(i, 8) == 0 then
				--positionOnBoard = positionOnBoard + 2
			--end
		--end
	end
end

function love.mousepressed(x, y, button, isTouch)
	if isTouch == isTouch then
		if x > middleOfBoard_x - 4*108*scalingNumber and x < middleOfBoard_x + 5*108*scalingNumber and y > middleOfBoard_y - 4*108*scalingNumber and y < middleOfBoard_y + 5*108*scalingNumber then
			onMap_x = math.floor((x - (middleOfBoard_x - 4*108*scalingNumber))/(108*scalingNumber))
			onMap_y = math.floor((y - (middleOfBoard_y - 4*108*scalingNumber))/(108*scalingNumber))
			targetTile = onMap_y * 10 + onMap_x + 11
			if movesAble_table[targetTile] ~= nil then
				if movesAble_table[targetTile] == "attack" then
					if entities_table[board_table[lastTile]].color == "white" then
						whiteKills_table[#whiteKills_table + 1] = entities_table[board_table[targetTile]]
					else
						blackKills_table[#blackKills_table + 1] = entities_table[board_table[targetTile]]
					end
				end
				board_table[targetTile] = board_table[lastTile]
				board_table[lastTile] = nil
				lastTile = 0
				movesAble_table = { }
				if currentPlayer == "White" then
					switchToPlayer("Black")
				else
					switchToPlayer("White")
				end
			elseif board_table[targetTile] ~= nil and entities_table[board_table[targetTile]].color == string.lower(currentPlayer) then
				showPossibleMoves (entities_table[board_table[targetTile]].piece, targetTile)
			else
				lastTile = 0
				movesAble_table = { }
			end
		end
	end
end

function showPossibleMoves (piece_picked, position)
	lastPickedPiece = piece_picked
	movesAble_table = { }
	if piece_picked == "pawn" then
		if entities_table[board_table[position]].color == "white" then
			if board_table [position - 10] == nil then
				positionAvaibleMove (position -10, entities_table[board_table[position]].color)
				if board_table [position - 20] == nil and math.floor(position/10) == 7 then
					positionAvaibleMove (position - 20, entities_table[board_table[position]].color)
				end
			end
			if board_table [position - 11] ~= nil then
				if entities_table[board_table[position - 11]].color ~= entities_table[board_table[position]].color then
					positionAvaibleMove (position -11, entities_table[board_table[position]].color)
				end
			end
			if board_table [position - 9] ~= nil then
				if entities_table[board_table[position - 9]].color ~= entities_table[board_table[position]].color then
					positionAvaibleMove (position - 9, entities_table[board_table[position]].color)
				end
			end
		else
			if board_table [position + 10] == nil then
				positionAvaibleMove (position +10, entities_table[board_table[position]].color)
				if board_table [position + 20] == nil and math.floor(position/10) == 2 then
					positionAvaibleMove (position + 20, entities_table[board_table[position]].color)
				end
			end
			if board_table [position + 11] ~= nil then
				if entities_table[board_table[position + 11]].color ~= entities_table[board_table[position]].color then
					positionAvaibleMove (position + 11, entities_table[board_table[position]].color)
				end
			end
			if board_table [position + 9] ~= nil then
				if entities_table[board_table[position + 9]].color ~= entities_table[board_table[position]].color then
					positionAvaibleMove (position + 9, entities_table[board_table[position]].color)
				end
			end
		end

	elseif piece_picked == "knight" then
		positionAvaibleMove (position + 8, entities_table[board_table[position]].color)
		positionAvaibleMove (position + 12, entities_table[board_table[position]].color)
		positionAvaibleMove (position + 19, entities_table[board_table[position]].color)
		positionAvaibleMove (position + 21, entities_table[board_table[position]].color)
		positionAvaibleMove (position - 8, entities_table[board_table[position]].color)
		positionAvaibleMove (position - 12, entities_table[board_table[position]].color)
		positionAvaibleMove (position -19, entities_table[board_table[position]].color)
		positionAvaibleMove (position -21, entities_table[board_table[position]].color)
	elseif piece_picked == "rook" then

		for i=1,7 do
			if math.floor(position/10) + i < 9 then
			positionAvaibleMove (position + i*10, entities_table[board_table[position]].color)
				if movesAble_table[position + i*10] == nil or movesAble_table[position + i*10] == "attack" then
					break
				end
			end
		end

		for i=1,7 do
			if position - math.floor(position/10)*10 + i < 9 then
			positionAvaibleMove (position + i, entities_table[board_table[position]].color)
				if movesAble_table[position + i] == nil or movesAble_table[position + i] == "attack" then
					break
				end
			end
		end

		for i=1,7 do
			if position - math.floor(position/10)*10 - i > 0 then
				positionAvaibleMove (position - i, entities_table[board_table[position]].color)
				if movesAble_table[position - i] == nil or  movesAble_table[position - i] == "attack" then
					break
				end
			end
		end
		for i=1,7 do
			if math.floor(position/10) - i > 0 then
				positionAvaibleMove (position - i*10, entities_table[board_table[position]].color)
				if movesAble_table[position - i*10] == nil or movesAble_table[position - 10*i] == "attack" then
					break
				end
			end
		end
	elseif piece_picked == "bishop" then

		for i=1,7 do
			if math.floor(position/10) + i < 9 and position - math.floor(position/10)*10 + i < 9 then
			positionAvaibleMove (position + i*11, entities_table[board_table[position]].color)
				if movesAble_table[position + i*11] == nil or movesAble_table[position + i*11] == "attack" then
					break
				end
			end
		end

		for i=1,7 do
			if math.floor(position/10) + i < 9 and position - math.floor(position/10)*10 - i > 0 then
			positionAvaibleMove (position + i*9, entities_table[board_table[position]].color)
				if movesAble_table[position + i*9] == nil or movesAble_table[position + i*9] == "attack" then
					break
				end
			end
		end

		for i=1,7 do
			if math.floor(position/10) - i > 0 and position - math.floor(position/10)*10 + i < 9 then
				positionAvaibleMove (position - i*9, entities_table[board_table[position]].color)
				if movesAble_table[position - i*9] == nil or movesAble_table[position - i*9] == "attack" then
					break
				end
			end
		end

		for i=1,7 do
			if math.floor(position/10) - i > 0 and position - math.floor(position/10)*10 - i > 0 then
				positionAvaibleMove (position - i*11, entities_table[board_table[position]].color)
				if movesAble_table[position - i*11] == nil or movesAble_table[position - i*11] == "attack" then
					break
				end
			end
		end

	elseif piece_picked == "king" then
		positionAvaibleMove (position + 1, entities_table[board_table[position]].color)
		positionAvaibleMove (position + 9, entities_table[board_table[position]].color)
		positionAvaibleMove (position + 10, entities_table[board_table[position]].color)
		positionAvaibleMove (position + 11, entities_table[board_table[position]].color)
		positionAvaibleMove (position - 1, entities_table[board_table[position]].color)
		positionAvaibleMove (position - 9, entities_table[board_table[position]].color)
		positionAvaibleMove (position - 10, entities_table[board_table[position]].color)
		positionAvaibleMove (position - 11, entities_table[board_table[position]].color)
	elseif piece_picked == "queen" then
		for i=1,7 do
			if math.floor(position/10) + i < 9 and position - math.floor(position/10)*10 + i < 9 then
			positionAvaibleMove (position + i*11, entities_table[board_table[position]].color)
				if movesAble_table[position + i*11] == nil or movesAble_table[position + i*11] == "attack" then
					break
				end
			end
		end

		for i=1,7 do
			if math.floor(position/10) + i < 9 and position - math.floor(position/10)*10 - i > 0 then
			positionAvaibleMove (position + i*9, entities_table[board_table[position]].color)
				if movesAble_table[position + i*9] == nil or movesAble_table[position + i*9] == "attack" then
					break
				end
			end
		end

		for i=1,7 do
			if math.floor(position/10) - i > 0 and position - math.floor(position/10)*10 + i < 9 then
				positionAvaibleMove (position - i*9, entities_table[board_table[position]].color)
				if movesAble_table[position - i*9] == nil or movesAble_table[position - i*9] == "attack" then
					break
				end
			end
		end

		for i=1,7 do
			if math.floor(position/10) - i > 0 and position - math.floor(position/10)*10 - i > 0 then
				positionAvaibleMove (position - i*11, entities_table[board_table[position]].color)
				if movesAble_table[position - i*11] == nil or movesAble_table[position - i*11] == "attack" then
					break
				end
			end
		end

		for i=1,7 do
			if math.floor(position/10) + i < 9 then
				positionAvaibleMove (position + i*10, entities_table[board_table[position]].color)
				if movesAble_table[position + i*10] == nil or movesAble_table[position + i*10] == "attack" then
					break
				end
			end
		end

		for i=1,7 do
			if position - math.floor(position/10)*10 + i < 9 then
			positionAvaibleMove (position + i, entities_table[board_table[position]].color)
				if movesAble_table[position + i] == nil or movesAble_table[position + i] == "attack" then
					break
				end
			end
		end

		for i=1,7 do
			if position - math.floor(position/10)*10 - i > 0 then
				positionAvaibleMove (position - i, entities_table[board_table[position]].color)
				if movesAble_table[position - i] == nil or  movesAble_table[position - i] == "attack" then
					break
				end
			end
		end
		for i=1,7 do
			if math.floor(position/10) - i > 0 then
				positionAvaibleMove (position - i*10, entities_table[board_table[position]].color)
				if movesAble_table[position - i*10] == nil or movesAble_table[position - 10*i] == "attack" then
					break
				end
			end
		end
	end
	lastTile = position
end

function positionAvaibleMove (position, color)
	if board_table[position] == nil then
		movesAble_table[position] = "blank"
	elseif entities_table[board_table[position]].color ~= color then
		movesAble_table[position] = "attack"
	else
		movesAble_table[position] = nil
	end
end
